/*
 * (C) Copyright 2002-2004
 * Gary Jennejohn, DENX Software Engineering, <gj@denx.de>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>

OUTPUT_FORMAT("elf32-littlearm", "elf32-littlearm", "elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_start)
SECTIONS
{
	. = 0x00000000;

	. = ALIGN(4);
	.text :
	{
		cpu/arm926ejs/start.o	(.text)
		*(.text)
	}

	. = ALIGN(4);
	.rodata : { *(SORT_BY_ALIGNMENT(SORT_BY_NAME(.rodata*))) }

	. = ALIGN(4);
	.data : { *(.data) }

	. = ALIGN(4);
	.got : { *(.got) }

	. = .;
	__u_boot_cmd_start = .;
	.u_boot_cmd : { *(.u_boot_cmd) }
	__u_boot_cmd_end = .;

#ifdef CONFIG_SYS_BOOTROM_UBOOT_LARGE
	/* Force the correct location of the ARM reset vectors
	 */
	.resetvec RESET_VECTOR_ADDRESS :
	{
		*(.resetvec)
	}

	/* One day, something will need to go into this space
	 */

	/* Ensure that the binary image is exact required size
	 * for AW+ / U-Boot upgrade (768KiB)
	 */
	.filler (_start + (0xc0000 - 0x4)) :
	{
		LONG(0xffffffff)
	}
#endif /* CONFIG_SYS_BOOTROM_UBOOT_LARGE */

	/*
	 * Make sure that the bss segment isn't linked at 0x0, otherwise its
	 * address won't be updated during relocation fixups.  Note that
	 * this is a temporary fix.  Code to dynamically the fixup the bss
	 * location will be added in the future.  When the bss relocation
	 * fixup code is present this workaround should be removed.
	 */
	. |= 0x10;

	. = ALIGN(4);
	__bss_start = .;
	.bss (NOLOAD) : { *(.bss) . = ALIGN(4); }
	_end = .;
}
